<template>
  <div class="container">
    <van-pull-refresh v-model="isLoading" @refresh="onRefresh" style="overflow: scroll; ">
      <van-list class="main" @load="load" :finished="isFinished">
        <div class="list" v-for="(item,index) in activities" v-bind:key="index" @click="onTapBoard(item.boardId)">
          <div class="above">
            <el-avatar :src="item.profilePhotoUrl"  class="avatar"/>
            <div class="center">
              <div class="name">{{item.name}}</div>
              <div v-if="item.relation===1" class="stat">发布了图板</div>
              <div v-else class="stat">参加了图板</div>
            </div>
          </div>
          <div class="below">
            <div class="title">{{item.boardTitle}}</div>
            <div class="detail">{{item.boardContent}}</div>
          </div>
        </div>
      </van-list>
    </van-pull-refresh>
    <div class="topBar">
      <el-avatar v-bind:src='profilePhotoUrl' class="avatar"/>
      <div class="center">
        <div class="name">{{myName}}</div>
        <div class="desc">{{introduction}}</div>
      </div>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import { PullRefresh, List } from 'vant'

Vue.use(PullRefresh)
Vue.use(List)

export default {
  name: 'Index',
  data () {
    return {
      myName: '',
      profilePhotoUrl: '',
      introduction: '',
      activities: [],
      page: 2,
      isLoading: false,
      isFinished: false
    }
  },
  mounted: function () {
    this.$api.myInfo().then((res) => {
      if (res.data.code === 401) {
        this.$toast('请先登陆！')
        return
      }
      this.myName = res.data.data.name
      this.profilePhotoUrl = res.data.data.profilePhotoUrl
      this.introduction = res.data.data.introduction
    }).catch(() => {
    })
    this.getActivities()
  },
  methods: {
    getActivities () {
      this.$api.getNews(1)
        .then((res) => {
          this.activities = res.data.data
        })
        .catch(() => {
          this.activities = []
        })
    },
    onTapBoard (boardId) {
      this.$router.push({
        path: `/boardDetail?id=${boardId}`,
        query: {
          boardId: boardId
        }
      })
    },
    load () {
      this.$api.getNews(this.page).then((res) => {
        this.activities.push(...res.data.data)
        if (res.data.data.length === 0) {
          this.isFinished = true
        }
        this.isLoading = false
      })
      this.page += 1
    },
    onRefresh () {
      this.page = 2
      this.isFinished = false
      this.getActivities()
      setTimeout(() => {
        this.$toast('刷新成功')
        this.isLoading = false
      }, 500)
    }
  }
}
</script>

<style scoped lang="less">
  .container {
    width: 100%;
    height: 100vh;
    overflow: scroll;
    display: flex;
    flex-direction: column;
    background-color: rgb(247, 247, 247);

    .topBar {
      position: fixed;
      height: 65px;
      width: 100%;
      background: #fff;
      box-shadow: 0px 0px 5px 0px #dadada;
      display: flex;

      .avatar {
        width: 41px;
        height: 41px;
        border: 1px solid #a9a9a9;
        background: #e8e8e8;
        border-radius: 50%;
        margin-top: 12px;
        margin-left: 3%;
        margin-right: 3%;
      }

      .center {
        margin-top: 15px;

        .name {
          font-size: 13px;
          color: #333333;
          font-weight: bolder;
        }

        .desc {
          margin-top: 4px;
          font-size: 10.5px;
          color: #646464;
        }
      }
    }

    .main {
      min-height: 70vh;
      margin-left: 3%;
      margin-right: 3%;
      flex: 1;
      overflow: auto;
      margin-top: 77px;
      padding-bottom: 45px;

      .list {
        background: #fff;
        margin-bottom: 15px;
        padding-left: 4.8%;
        padding-right: 4.8%;

        .above {
          display: flex;
          align-items: center;

          .avatar {
            width: 33px;
            height: 33px;
            border: 1px solid #a9a9a9;
            background: #e8e8e8;
            border-radius: 50%;
            margin-top: 12px;
            margin-right: 3.5%;
          }

          .center {
            flex: 1;

            .name {
              font-size: 12.7px;
              color: #3d3d3d;
              font-weight: bolder;
              margin-top: 13px;
            }

            .stat {
              margin-top: 4px;
              font-size: 11px;
              color: #3170ff;
            }
          }
        }

        .below {
          display: grid;

          .title {
            font-weight: bold;
            font-size: 13.5px;
            color: #333333;
            margin-top: 10px;
          }

          .detail {
            font-size: 12px;
            color: #7c7c7c;
            margin-top: 6px;
            margin-bottom: 20px;
          }

          .date {
            font-size: 11px;
            color: #acacac;
            text-align: right;
          }
        }
      }
    }
  }
</style>
